
--Sunset.lua
--it's good form to mention the name of this script.
--these dashes mean that these are comments.


--This is a function that will be called by the main program.
function DoGradient (gr1,gr2)
local r,g,b,r2,g2,b2,r3,g3,b3,r4,g4,b4
local x,y, y2,y3

--we have to unpack the 'packed' hex colors.

r2,g2,b2 = decimal2rgb(gr1)

r3,g3,b3 = decimal2rgb(gr2)


for y = 0, height - 1 do

--setup the gradient colors.
  y2=y/height
  y3= 1-y2
  r4=(r2*y3)+(r3*y2)
  g4=(g2*y3)+(g3*y2)
  b4=(b2*y3)+(b3*y2)
--
  for x = 0, width - 1 do
    r, g, b = get_rgb(x, y)

    --combine the gradient with the image with multiplication.
    r=r*r4
    g=g*g4
    b=b*b4

    set_rgb(x, y, r, g, b)
  end
  progress(y2)
end
progress(0) -- reset the progress bar after usage.
Dog_Refresh()
end



-----------------------------------------------------------------
-- The main part of the program where we setup the gui
-- and respond to the user
-----------------------------------------------------------------

Dog_SaveUndo()

--we are going to open a panel with a couple of controls on it.

--first, lets give the panel (window) a name.

GUI_SetCaption("Sunset filter")

--we will now add a couple of controls for selecting color.

--make use of the "hex" function to convert hex colors into decimal numbers.
--if you're not familiar with colors represented in hex...
--hex is a way to represent numbers with 16 digits instead of ten (decimal)
--hex numbers are 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f, for 0-16.
--to represent numbers between 0-255, we use two hex numbers.
--00 = 0.  FF = 255.
--to represent 24 bit color, we use 3 sets of hex numbers like...
--FF0000 would be bright blue.  0000FF would be bright red.

--lets add the conrols.

h1 = GUI_AddControl("Colorbox", "", hex("44AAFF"), 0, 0)
h2 = GUI_AddControl("Colorbox", "", hex("FFFFFF") ,0, 0)
GUI_AddControl("Line")
h3 = GUI_AddControl("Check","Animated",0)
-- now that we've added all our controls, we can open the panel.

GUI_OpenPanel()

--this is our event loop.

repeat
idx, retval, retstr = GUI_WaitOnEvent()

g1,dummy=GUI_GetSettings(h1)
g2,dummy=GUI_GetSettings(h2)
g3,dummy=GUI_GetSettings(h3)

--update the screen everytime the user clicks a control.
if idx >=0 then
DoGradient(g1,g2)
end

until idx < 0


--example of getting the settengs of a specific control
--read any settings before closing the panel
--value, string = GUI_GetSettings(h1)

--always close the panel before exiting or it will stay around.

--if animated
if idx == -1 then
if g3== 1 then
  --animate it
  Dog_RestoreUndo()
Dog_GetBuffer()
Dog_Refresh()
  local frame,endframe
  endframe=Dog_GetTotalFrames()

  Dog_GotoFrame(0)

    for frame=0,endframe-1 do
       Dog_GotoFrame(frame)
       DoGradient(g1,g2)
    end
  Dog_GotoFrame(0)
  end
end

if idx == -2 then
Dog_RestoreUndo()
Dog_GetBuffer()
Dog_Refresh()
end

GUI_ClosePanel()